import{S as di,i as _i,s as gi,e as o,k as f,w as h,t as l,M as $i,c as r,d as t,m as c,a as s,x as d,h as u,b as p,N as qa,G as a,g as n,y as _,q as g,o as $,B as v,v as vi}from"../../chunks/vendor-hf-doc-builder.js";import{T as wi}from"../../chunks/Tip-hf-doc-builder.js";import{I as ze}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as A}from"../../chunks/CodeBlock-hf-doc-builder.js";function bi(Me){let m,N;return{c(){m=o("p"),N=l("\u{1F4A1} A full training run takes 2 hours on 4xV100 GPUs.")},l(w){m=r(w,"P",{});var y=s(m);N=u(y,"\u{1F4A1} A full training run takes 2 hours on 4xV100 GPUs."),y.forEach(t)},m(w,y){n(w,m,y),a(m,N)},d(w){w&&t(m)}}}function yi(Me){let m,N,w,y,ye,B,Ut,ke,Nt,Be,he,Ot,Ve,E,Sa,Ye,O,Ct,V,jt,Ht,Le,de,It,Re,Y,Je,C,Ft,L,Gt,Dt,Ke,R,Qe,_e,zt,We,J,Xe,ge,Mt,Ze,K,et,q,j,Ee,Q,Bt,xe,Vt,tt,$e,Yt,at,W,it,S,H,Pe,X,Lt,Ae,Rt,nt,ve,Jt,ot,Z,rt,x,Kt,qe,Qt,Wt,Se,Xt,Zt,st,ee,lt,T,I,Te,te,ea,Ue,ta,ut,b,aa,ae,ia,na,Ne,oa,ra,Oe,sa,la,we,ua,pa,pt,F,fa,Ce,ca,ma,ft,G,ct,D,ha,ie,da,_a,mt,ne,ht,oe,je,Ta,dt,z,ga,re,$a,va,_t,se,gt,le,He,Ua,$t,U,M,Ie,ue,wa,Fe,ba,vt,k,Ge,ya,ka,pe,Ea,xa,De,Pa,Aa,wt,fe,bt;return B=new ze({}),Y=new A({props:{code:"pip install diffusers[training] accelerate datasets",highlighted:"pip install diffusers[training] accelerate datasets"}}),R=new A({props:{code:"accelerate config",highlighted:"accelerate config"}}),J=new A({props:{code:"accelerate config default",highlighted:"accelerate config default"}}),K=new A({props:{code:`from accelerate.utils import write_basic_config

write_basic_config()`,highlighted:`from accelerate.utils import write_basic_config

write_basic_config()`}}),Q=new ze({}),W=new A({props:{code:"--push_to_hub",highlighted:"--push_to_hub"}}),X=new ze({}),Z=new A({props:{code:"--checkpointing_steps=500",highlighted:"--checkpointing_steps=500"}}),ee=new A({props:{code:'--resume_from_checkpoint="checkpoint-1500"',highlighted:'--resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),te=new ze({}),G=new wi({props:{$$slots:{default:[bi]},$$scope:{ctx:Me}}}),ne=new A({props:{code:`accelerate launch train_unconditional.py \\
  --dataset_name="huggan/flowers-102-categories" \\
  --resolution=64 \\
  --output_dir="ddpm-ema-flowers-64" \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision=no \\
  --push_to_hub`,highlighted:`accelerate launch train_unconditional.py \\
  --dataset_name=<span class="hljs-string">&quot;huggan/flowers-102-categories&quot;</span> \\
  --resolution=64 \\
  --output_dir=<span class="hljs-string">&quot;ddpm-ema-flowers-64&quot;</span> \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision=no \\
  --push_to_hub`}}),se=new A({props:{code:`accelerate launch train_unconditional.py \\
  --dataset_name="huggan/pokemon" \\
  --resolution=64 \\
  --output_dir="ddpm-ema-pokemon-64" \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision=no \\
  --push_to_hub`,highlighted:`accelerate launch train_unconditional.py \\
  --dataset_name=<span class="hljs-string">&quot;huggan/pokemon&quot;</span> \\
  --resolution=64 \\
  --output_dir=<span class="hljs-string">&quot;ddpm-ema-pokemon-64&quot;</span> \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision=no \\
  --push_to_hub`}}),ue=new ze({}),fe=new A({props:{code:`accelerate launch --mixed_precision="fp16" --multi_gpu train_unconditional.py \\
  --dataset_name="huggan/pokemon" \\
  --resolution=64 --center_crop --random_flip \\
  --output_dir="ddpm-ema-pokemon-64" \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --use_ema \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision="fp16" \\
  --logger="wandb"`,highlighted:`accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> --multi_gpu train_unconditional.py \\
  --dataset_name=<span class="hljs-string">&quot;huggan/pokemon&quot;</span> \\
  --resolution=64 --center_crop --random_flip \\
  --output_dir=<span class="hljs-string">&quot;ddpm-ema-pokemon-64&quot;</span> \\
  --train_batch_size=16 \\
  --num_epochs=100 \\
  --gradient_accumulation_steps=1 \\
  --use_ema \\
  --learning_rate=1e-4 \\
  --lr_warmup_steps=500 \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --logger=<span class="hljs-string">&quot;wandb&quot;</span>`}}),{c(){m=o("meta"),N=f(),w=o("h1"),y=o("a"),ye=o("span"),h(B.$$.fragment),Ut=f(),ke=o("span"),Nt=l("Unconditional image generation"),Be=f(),he=o("p"),Ot=l("Unconditional image generation is not conditioned on any text or images, unlike text- or image-to-image models. It only generates images that resemble its training data distribution."),Ve=f(),E=o("iframe"),Ye=f(),O=o("p"),Ct=l("This guide will show you how to train an unconditional image generation model on existing datasets as well as your own custom dataset. All the training scripts for unconditional image generation can be found "),V=o("a"),jt=l("here"),Ht=l(" if you\u2019re interested in learning more about the training details."),Le=f(),de=o("p"),It=l("Before running the script, make sure you install the library\u2019s training dependencies:"),Re=f(),h(Y.$$.fragment),Je=f(),C=o("p"),Ft=l("Next, initialize an \u{1F917} "),L=o("a"),Gt=l("Accelerate"),Dt=l(" environment with:"),Ke=f(),h(R.$$.fragment),Qe=f(),_e=o("p"),zt=l("To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),We=f(),h(J.$$.fragment),Xe=f(),ge=o("p"),Mt=l("Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),Ze=f(),h(K.$$.fragment),et=f(),q=o("h2"),j=o("a"),Ee=o("span"),h(Q.$$.fragment),Bt=f(),xe=o("span"),Vt=l("Upload model to Hub"),tt=f(),$e=o("p"),Yt=l("You can upload your model on the Hub by adding the following argument to the training script:"),at=f(),h(W.$$.fragment),it=f(),S=o("h2"),H=o("a"),Pe=o("span"),h(X.$$.fragment),Lt=f(),Ae=o("span"),Rt=l("Save and load checkpoints"),nt=f(),ve=o("p"),Jt=l("It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),ot=f(),h(Z.$$.fragment),rt=f(),x=o("p"),Kt=l("The full training state is saved in a subfolder in the "),qe=o("code"),Qt=l("output_dir"),Wt=l(" every 500 steps, which allows you to load a checkpoint and resume training if you pass the "),Se=o("code"),Xt=l("--resume_from_checkpoint"),Zt=l(" argument to the training script:"),st=f(),h(ee.$$.fragment),lt=f(),T=o("h2"),I=o("a"),Te=o("span"),h(te.$$.fragment),ea=f(),Ue=o("span"),ta=l("Finetuning"),ut=f(),b=o("p"),aa=l("You\u2019re ready to launch the "),ae=o("a"),ia=l("training script"),na=l(" now! Specify the dataset name to finetune on with the "),Ne=o("code"),oa=l("--dataset_name"),ra=l(" argument and then save it to the path in "),Oe=o("code"),sa=l("--output_dir"),la=l(". To use your own dataset, take a look at the "),we=o("a"),ua=l("Create a dataset for training"),pa=l(" guide."),pt=f(),F=o("p"),fa=l("The training script creates and saves a "),Ce=o("code"),ca=l("diffusion_pytorch_model.bin"),ma=l(" file in your repository."),ft=f(),h(G.$$.fragment),ct=f(),D=o("p"),ha=l("For example, to finetune on the "),ie=o("a"),da=l("Oxford Flowers"),_a=l(" dataset:"),mt=f(),h(ne.$$.fragment),ht=f(),oe=o("div"),je=o("img"),dt=f(),z=o("p"),ga=l("Or if you want to train your model on the "),re=o("a"),$a=l("Pokemon"),va=l(" dataset:"),_t=f(),h(se.$$.fragment),gt=f(),le=o("div"),He=o("img"),$t=f(),U=o("h3"),M=o("a"),Ie=o("span"),h(ue.$$.fragment),wa=f(),Fe=o("span"),ba=l("Training with multiple GPUs"),vt=f(),k=o("p"),Ge=o("code"),ya=l("accelerate"),ka=l(" allows for seamless multi-GPU training. Follow the instructions "),pe=o("a"),Ea=l("here"),xa=l(`
for running distributed training with `),De=o("code"),Pa=l("accelerate"),Aa=l(". Here is an example command:"),wt=f(),h(fe.$$.fragment),this.h()},l(e){const i=$i('[data-svelte="svelte-1phssyn"]',document.head);m=r(i,"META",{name:!0,content:!0}),i.forEach(t),N=c(e),w=r(e,"H1",{class:!0});var ce=s(w);y=r(ce,"A",{id:!0,class:!0,href:!0});var Na=s(y);ye=r(Na,"SPAN",{});var Oa=s(ye);d(B.$$.fragment,Oa),Oa.forEach(t),Na.forEach(t),Ut=c(ce),ke=r(ce,"SPAN",{});var Ca=s(ke);Nt=u(Ca,"Unconditional image generation"),Ca.forEach(t),ce.forEach(t),Be=c(e),he=r(e,"P",{});var ja=s(he);Ot=u(ja,"Unconditional image generation is not conditioned on any text or images, unlike text- or image-to-image models. It only generates images that resemble its training data distribution."),ja.forEach(t),Ve=c(e),E=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),s(E).forEach(t),Ye=c(e),O=r(e,"P",{});var yt=s(O);Ct=u(yt,"This guide will show you how to train an unconditional image generation model on existing datasets as well as your own custom dataset. All the training scripts for unconditional image generation can be found "),V=r(yt,"A",{href:!0,rel:!0});var Ha=s(V);jt=u(Ha,"here"),Ha.forEach(t),Ht=u(yt," if you\u2019re interested in learning more about the training details."),yt.forEach(t),Le=c(e),de=r(e,"P",{});var Ia=s(de);It=u(Ia,"Before running the script, make sure you install the library\u2019s training dependencies:"),Ia.forEach(t),Re=c(e),d(Y.$$.fragment,e),Je=c(e),C=r(e,"P",{});var kt=s(C);Ft=u(kt,"Next, initialize an \u{1F917} "),L=r(kt,"A",{href:!0,rel:!0});var Fa=s(L);Gt=u(Fa,"Accelerate"),Fa.forEach(t),Dt=u(kt," environment with:"),kt.forEach(t),Ke=c(e),d(R.$$.fragment,e),Qe=c(e),_e=r(e,"P",{});var Ga=s(_e);zt=u(Ga,"To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),Ga.forEach(t),We=c(e),d(J.$$.fragment,e),Xe=c(e),ge=r(e,"P",{});var Da=s(ge);Mt=u(Da,"Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),Da.forEach(t),Ze=c(e),d(K.$$.fragment,e),et=c(e),q=r(e,"H2",{class:!0});var Et=s(q);j=r(Et,"A",{id:!0,class:!0,href:!0});var za=s(j);Ee=r(za,"SPAN",{});var Ma=s(Ee);d(Q.$$.fragment,Ma),Ma.forEach(t),za.forEach(t),Bt=c(Et),xe=r(Et,"SPAN",{});var Ba=s(xe);Vt=u(Ba,"Upload model to Hub"),Ba.forEach(t),Et.forEach(t),tt=c(e),$e=r(e,"P",{});var Va=s($e);Yt=u(Va,"You can upload your model on the Hub by adding the following argument to the training script:"),Va.forEach(t),at=c(e),d(W.$$.fragment,e),it=c(e),S=r(e,"H2",{class:!0});var xt=s(S);H=r(xt,"A",{id:!0,class:!0,href:!0});var Ya=s(H);Pe=r(Ya,"SPAN",{});var La=s(Pe);d(X.$$.fragment,La),La.forEach(t),Ya.forEach(t),Lt=c(xt),Ae=r(xt,"SPAN",{});var Ra=s(Ae);Rt=u(Ra,"Save and load checkpoints"),Ra.forEach(t),xt.forEach(t),nt=c(e),ve=r(e,"P",{});var Ja=s(ve);Jt=u(Ja,"It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),Ja.forEach(t),ot=c(e),d(Z.$$.fragment,e),rt=c(e),x=r(e,"P",{});var be=s(x);Kt=u(be,"The full training state is saved in a subfolder in the "),qe=r(be,"CODE",{});var Ka=s(qe);Qt=u(Ka,"output_dir"),Ka.forEach(t),Wt=u(be," every 500 steps, which allows you to load a checkpoint and resume training if you pass the "),Se=r(be,"CODE",{});var Qa=s(Se);Xt=u(Qa,"--resume_from_checkpoint"),Qa.forEach(t),Zt=u(be," argument to the training script:"),be.forEach(t),st=c(e),d(ee.$$.fragment,e),lt=c(e),T=r(e,"H2",{class:!0});var Pt=s(T);I=r(Pt,"A",{id:!0,class:!0,href:!0});var Wa=s(I);Te=r(Wa,"SPAN",{});var Xa=s(Te);d(te.$$.fragment,Xa),Xa.forEach(t),Wa.forEach(t),ea=c(Pt),Ue=r(Pt,"SPAN",{});var Za=s(Ue);ta=u(Za,"Finetuning"),Za.forEach(t),Pt.forEach(t),ut=c(e),b=r(e,"P",{});var P=s(b);aa=u(P,"You\u2019re ready to launch the "),ae=r(P,"A",{href:!0,rel:!0});var ei=s(ae);ia=u(ei,"training script"),ei.forEach(t),na=u(P," now! Specify the dataset name to finetune on with the "),Ne=r(P,"CODE",{});var ti=s(Ne);oa=u(ti,"--dataset_name"),ti.forEach(t),ra=u(P," argument and then save it to the path in "),Oe=r(P,"CODE",{});var ai=s(Oe);sa=u(ai,"--output_dir"),ai.forEach(t),la=u(P,". To use your own dataset, take a look at the "),we=r(P,"A",{href:!0});var ii=s(we);ua=u(ii,"Create a dataset for training"),ii.forEach(t),pa=u(P," guide."),P.forEach(t),pt=c(e),F=r(e,"P",{});var At=s(F);fa=u(At,"The training script creates and saves a "),Ce=r(At,"CODE",{});var ni=s(Ce);ca=u(ni,"diffusion_pytorch_model.bin"),ni.forEach(t),ma=u(At," file in your repository."),At.forEach(t),ft=c(e),d(G.$$.fragment,e),ct=c(e),D=r(e,"P",{});var qt=s(D);ha=u(qt,"For example, to finetune on the "),ie=r(qt,"A",{href:!0,rel:!0});var oi=s(ie);da=u(oi,"Oxford Flowers"),oi.forEach(t),_a=u(qt," dataset:"),qt.forEach(t),mt=c(e),d(ne.$$.fragment,e),ht=c(e),oe=r(e,"DIV",{class:!0});var ri=s(oe);je=r(ri,"IMG",{src:!0}),ri.forEach(t),dt=c(e),z=r(e,"P",{});var St=s(z);ga=u(St,"Or if you want to train your model on the "),re=r(St,"A",{href:!0,rel:!0});var si=s(re);$a=u(si,"Pokemon"),si.forEach(t),va=u(St," dataset:"),St.forEach(t),_t=c(e),d(se.$$.fragment,e),gt=c(e),le=r(e,"DIV",{class:!0});var li=s(le);He=r(li,"IMG",{src:!0}),li.forEach(t),$t=c(e),U=r(e,"H3",{class:!0});var Tt=s(U);M=r(Tt,"A",{id:!0,class:!0,href:!0});var ui=s(M);Ie=r(ui,"SPAN",{});var pi=s(Ie);d(ue.$$.fragment,pi),pi.forEach(t),ui.forEach(t),wa=c(Tt),Fe=r(Tt,"SPAN",{});var fi=s(Fe);ba=u(fi,"Training with multiple GPUs"),fi.forEach(t),Tt.forEach(t),vt=c(e),k=r(e,"P",{});var me=s(k);Ge=r(me,"CODE",{});var ci=s(Ge);ya=u(ci,"accelerate"),ci.forEach(t),ka=u(me," allows for seamless multi-GPU training. Follow the instructions "),pe=r(me,"A",{href:!0,rel:!0});var mi=s(pe);Ea=u(mi,"here"),mi.forEach(t),xa=u(me,`
for running distributed training with `),De=r(me,"CODE",{});var hi=s(De);Pa=u(hi,"accelerate"),hi.forEach(t),Aa=u(me,". Here is an example command:"),me.forEach(t),wt=c(e),d(fe.$$.fragment,e),this.h()},h(){p(m,"name","hf:doc:metadata"),p(m,"content",JSON.stringify(ki)),p(y,"id","unconditional-image-generation"),p(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(y,"href","#unconditional-image-generation"),p(w,"class","relative group"),qa(E.src,Sa="https://stevhliu-ddpm-butterflies-128.hf.space")||p(E,"src",Sa),p(E,"frameborder","0"),p(E,"width","850"),p(E,"height","550"),p(V,"href","https://github.com/huggingface/diffusers/tree/main/examples/unconditional_image_generation"),p(V,"rel","nofollow"),p(L,"href","https://github.com/huggingface/accelerate/"),p(L,"rel","nofollow"),p(j,"id","upload-model-to-hub"),p(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(j,"href","#upload-model-to-hub"),p(q,"class","relative group"),p(H,"id","save-and-load-checkpoints"),p(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(H,"href","#save-and-load-checkpoints"),p(S,"class","relative group"),p(I,"id","finetuning"),p(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(I,"href","#finetuning"),p(T,"class","relative group"),p(ae,"href","https://github.com/huggingface/diffusers/blob/main/examples/unconditional_image_generation/train_unconditional.py"),p(ae,"rel","nofollow"),p(we,"href","create_dataset"),p(ie,"href","https://huggingface.co/datasets/huggan/flowers-102-categories"),p(ie,"rel","nofollow"),qa(je.src,Ta="https://user-images.githubusercontent.com/26864830/180248660-a0b143d0-b89a-42c5-8656-2ebf6ece7e52.png")||p(je,"src",Ta),p(oe,"class","flex justify-center"),p(re,"href","https://huggingface.co/datasets/huggan/pokemon"),p(re,"rel","nofollow"),qa(He.src,Ua="https://user-images.githubusercontent.com/26864830/180248200-928953b4-db38-48db-b0c6-8b740fe6786f.png")||p(He,"src",Ua),p(le,"class","flex justify-center"),p(M,"id","training-with-multiple-gpus"),p(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(M,"href","#training-with-multiple-gpus"),p(U,"class","relative group"),p(pe,"href","https://huggingface.co/docs/accelerate/basic_tutorials/launch"),p(pe,"rel","nofollow")},m(e,i){a(document.head,m),n(e,N,i),n(e,w,i),a(w,y),a(y,ye),_(B,ye,null),a(w,Ut),a(w,ke),a(ke,Nt),n(e,Be,i),n(e,he,i),a(he,Ot),n(e,Ve,i),n(e,E,i),n(e,Ye,i),n(e,O,i),a(O,Ct),a(O,V),a(V,jt),a(O,Ht),n(e,Le,i),n(e,de,i),a(de,It),n(e,Re,i),_(Y,e,i),n(e,Je,i),n(e,C,i),a(C,Ft),a(C,L),a(L,Gt),a(C,Dt),n(e,Ke,i),_(R,e,i),n(e,Qe,i),n(e,_e,i),a(_e,zt),n(e,We,i),_(J,e,i),n(e,Xe,i),n(e,ge,i),a(ge,Mt),n(e,Ze,i),_(K,e,i),n(e,et,i),n(e,q,i),a(q,j),a(j,Ee),_(Q,Ee,null),a(q,Bt),a(q,xe),a(xe,Vt),n(e,tt,i),n(e,$e,i),a($e,Yt),n(e,at,i),_(W,e,i),n(e,it,i),n(e,S,i),a(S,H),a(H,Pe),_(X,Pe,null),a(S,Lt),a(S,Ae),a(Ae,Rt),n(e,nt,i),n(e,ve,i),a(ve,Jt),n(e,ot,i),_(Z,e,i),n(e,rt,i),n(e,x,i),a(x,Kt),a(x,qe),a(qe,Qt),a(x,Wt),a(x,Se),a(Se,Xt),a(x,Zt),n(e,st,i),_(ee,e,i),n(e,lt,i),n(e,T,i),a(T,I),a(I,Te),_(te,Te,null),a(T,ea),a(T,Ue),a(Ue,ta),n(e,ut,i),n(e,b,i),a(b,aa),a(b,ae),a(ae,ia),a(b,na),a(b,Ne),a(Ne,oa),a(b,ra),a(b,Oe),a(Oe,sa),a(b,la),a(b,we),a(we,ua),a(b,pa),n(e,pt,i),n(e,F,i),a(F,fa),a(F,Ce),a(Ce,ca),a(F,ma),n(e,ft,i),_(G,e,i),n(e,ct,i),n(e,D,i),a(D,ha),a(D,ie),a(ie,da),a(D,_a),n(e,mt,i),_(ne,e,i),n(e,ht,i),n(e,oe,i),a(oe,je),n(e,dt,i),n(e,z,i),a(z,ga),a(z,re),a(re,$a),a(z,va),n(e,_t,i),_(se,e,i),n(e,gt,i),n(e,le,i),a(le,He),n(e,$t,i),n(e,U,i),a(U,M),a(M,Ie),_(ue,Ie,null),a(U,wa),a(U,Fe),a(Fe,ba),n(e,vt,i),n(e,k,i),a(k,Ge),a(Ge,ya),a(k,ka),a(k,pe),a(pe,Ea),a(k,xa),a(k,De),a(De,Pa),a(k,Aa),n(e,wt,i),_(fe,e,i),bt=!0},p(e,[i]){const ce={};i&2&&(ce.$$scope={dirty:i,ctx:e}),G.$set(ce)},i(e){bt||(g(B.$$.fragment,e),g(Y.$$.fragment,e),g(R.$$.fragment,e),g(J.$$.fragment,e),g(K.$$.fragment,e),g(Q.$$.fragment,e),g(W.$$.fragment,e),g(X.$$.fragment,e),g(Z.$$.fragment,e),g(ee.$$.fragment,e),g(te.$$.fragment,e),g(G.$$.fragment,e),g(ne.$$.fragment,e),g(se.$$.fragment,e),g(ue.$$.fragment,e),g(fe.$$.fragment,e),bt=!0)},o(e){$(B.$$.fragment,e),$(Y.$$.fragment,e),$(R.$$.fragment,e),$(J.$$.fragment,e),$(K.$$.fragment,e),$(Q.$$.fragment,e),$(W.$$.fragment,e),$(X.$$.fragment,e),$(Z.$$.fragment,e),$(ee.$$.fragment,e),$(te.$$.fragment,e),$(G.$$.fragment,e),$(ne.$$.fragment,e),$(se.$$.fragment,e),$(ue.$$.fragment,e),$(fe.$$.fragment,e),bt=!1},d(e){t(m),e&&t(N),e&&t(w),v(B),e&&t(Be),e&&t(he),e&&t(Ve),e&&t(E),e&&t(Ye),e&&t(O),e&&t(Le),e&&t(de),e&&t(Re),v(Y,e),e&&t(Je),e&&t(C),e&&t(Ke),v(R,e),e&&t(Qe),e&&t(_e),e&&t(We),v(J,e),e&&t(Xe),e&&t(ge),e&&t(Ze),v(K,e),e&&t(et),e&&t(q),v(Q),e&&t(tt),e&&t($e),e&&t(at),v(W,e),e&&t(it),e&&t(S),v(X),e&&t(nt),e&&t(ve),e&&t(ot),v(Z,e),e&&t(rt),e&&t(x),e&&t(st),v(ee,e),e&&t(lt),e&&t(T),v(te),e&&t(ut),e&&t(b),e&&t(pt),e&&t(F),e&&t(ft),v(G,e),e&&t(ct),e&&t(D),e&&t(mt),v(ne,e),e&&t(ht),e&&t(oe),e&&t(dt),e&&t(z),e&&t(_t),v(se,e),e&&t(gt),e&&t(le),e&&t($t),e&&t(U),v(ue),e&&t(vt),e&&t(k),e&&t(wt),v(fe,e)}}}const ki={local:"unconditional-image-generation",sections:[{local:"upload-model-to-hub",title:"Upload model to Hub"},{local:"save-and-load-checkpoints",title:"Save and load checkpoints"},{local:"finetuning",sections:[{local:"training-with-multiple-gpus",title:"Training with multiple GPUs"}],title:"Finetuning"}],title:"Unconditional image generation"};function Ei(Me){return vi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Si extends di{constructor(m){super();_i(this,m,Ei,yi,gi,{})}}export{Si as default,ki as metadata};
